Developer Documentation

Public Member Functions | Private Slots | Private Member Functions | Private Attributes | List of all members
Core Class Reference

`#include <OpenFlipper/Core/Core.hh>`

Inheritance diagram for Core:

## Public Slots
scriptable slots
Get a Pointer to the Plugin with given _name (if it is loaded)
void | updateView ()
| Called when a plugin requests an update in the viewer. More...
void | blockScenegraphUpdates (bool _block)
| Called when a plugin wants to lock or unlock scenegraph updates.
void | updateUI ()
| process events during script execution to keep the ui alive
void | clearAll ()
| Clear all data objects.
void | deleteObject (int _id)
| Called to delete an object.
void | setObjectComment (int objId, QString key, QString comment)
| Called when a plugin requests an update in the viewer. More...
void | clearObjectComment (int objId, QString key)
| Called when a plugin requests an update in the viewer. More...
void | clearAllComments (int objId)
| Called when a plugin requests an update in the viewer. More...
void | fullscreen (bool _state)
| set fullscreen mode
void | showViewModeControls (bool _show)
| Show or Hide the viewmode control widget.
void | loggerState (int _state)
| Change the logging window state.
void | enableOpenMeshErrorLog (bool _state)
| Enable or disable OpenMesh error logging.
void | showToolbox (bool _state)
| Show or hide toolbox.
void | showStatusBar (bool _state)
| Show or hide Status Bar.
void | multiViewMode (int _mode)
| Switch the multiView Mode.
void | restrictFrameRate (bool _enable)
| Enable or disable framerate restriction.
void | setMaxFrameRate (int _rate)
| set the maximal framerate ( automatically enables framerate restriction )
void | snapshotBaseFileName (QString _fname, unsigned int _viewerId=0)
void | snapshotFileType (QString _type, unsigned int _viewerId=0)
| Set the file type for snapshots.
void | snapshotCounterStart (const int _counter, unsigned int _viewerId=0)
| Set the start index for the snapshot counter.
void | snapshot (unsigned int _viewerId=0, int _width=0, int _height=0, bool _alpha=false, bool _hideCoordsys=false, int _numSamples=1)
void | applicationSnapshot ()
| Take a snapshot from the whole app.
void | applicationSnapshotName (QString _name)
| Set the baseName for the application snapshot.
void | viewerSnapshot ()
| Take a snapshot from all viewers.
void | viewerSnapshot (QString file_name, bool store_comments, bool comments_visible_only, bool comments_targeted_only, bool store_material_info, int snapshot_width, int snapshot_height, bool snapshot_transparent, bool hide_coord_sys, int snapshot_multisampling, bool store_view)
| Scriptable snapshot method offering full control.
void | resizeViewers (int _width, int _height)
| resize the examinerViewer
void | resizeApplication (int _width, int _height)
| resize the whole Application
void | writeVersionNumbers (QString _filename)
| write the current versions of all plugins to ini file
QList< int > | objectList (QString _selection, QStringList _types)
| return the list of available object that has the given selection and type
void | blockSceneGraphUpdates ()
| Block the scenegraph updates.
void | unblockSceneGraphUpdates ()
| Unblock the scenegraph updates.
void | setView (QString view)
| Called when a plugin requests an update in the viewer. More...
void | setViewAndWindowGeometry (QString view)
| Called when a plugin requests an update in the viewer. More...
Scripting functions for controlling view modes
void | addViewModeToolboxes (QString _modeName, QString _toolboxList)
| Scripting function to set toolboxes in a view mode. More...
void | addViewModeToolbars (QString _modeName, QString _toolbarList)
| Scripting function to set toolbars in a view mode. More...
void | addViewModeContextMenus (QString _modeName, QString _contextMenuList)
| Scripting function to set context menus in a view mode. More...
void | addViewModeIcon (QString _modeName, QString _iconName)
| Scripting function to set an icon for a view mode. More...
void | setToolBoxSide (QString _side)
| Scripting function to set the side of the main window on which the toolbox should be displayed. More...
void | setToolBoxActive (QString _toolBoxName, bool _active)
| Scripting function to activate or deactivate a toolbox. More...
Load / Save slots
bool | saveObject (int _id, QString _filename)
| Save an object. More...
void | saveObject (int _id, QString _filename, int _pluginID)
void | saveObjects (IdList _ids, QString _filename, int _pluginID)
bool | saveObjectTo (int _id, QString _filename)
bool | saveObjectsTo (IdList _ids, QString _filename)
void | saveAllObjects ()
| Slot for saving objects from Menu. More...
void | saveAllObjectsTo ()
| Slot for saving objects to a new location. More...
void | saveSettings ()
| Save current status to a settings file. Solicit file name through dialog. More...
void | saveSettings (QString filePath, bool is_saveObjectInfo, bool is_targetOnly, bool is_saveAll, bool is_askOverwrite, bool is_saveProgramSettings, bool is_savePluginSettings)
| Save current status to a the provided settings file.
void | loadObject ()
| Open Load Widget. More...
void | loadSettings ()
| Load status from file. More...
void | loadSettings (QString _filename)
| Load status from file. More...
int | getObjectId (QString _filename)
| Get object id from filename.
void | deserializeMaterialProperties (int _objId, QString _props)
| Serialize material properties. More...
QString | serializeMaterialProperties (int _objId)
| Serialize material properties. More...
Exit functions
void | exitApplication ()
| exit the current application
void | exitFailure ()
| Aborts the application with an error code. More...
void | finishSplash ()
| exit the current application

## Signals
Signals send to Plugins
void | allCleared ()
| Signal send to plugins when whole scene is cleared.
void | signalObjectUpdated (int)
| When this Signal is emitted all Plugins are informed that the object list changed.
void | signalObjectUpdated (int, const UpdateType &)
| When this Signal is emitted all Plugins are informed that some type of update was performed on an object.
void | PluginWheelEvent (QWheelEvent *, const std::string &)
| When this Signal is emitted when a Wheel Event occures.
void | PluginMouseEvent (QMouseEvent *)
| When this Signal is emitted when a Mouse Event occures.
void | PluginMouseEventLight (QMouseEvent *)
| Emitted when an light event occurs.
void | objectSelectionChanged (int)
| This signal is emitted if the object has been changed (source/target)
void | pluginViewChanged ()
| This signal is emitted if one of the viewers updated its view.
void | pluginSceneDrawn ()
| This signal is emitted after the scene has been drawn.
void | addTexture (QString, QString, uint, int)
| The texture with the given name and filename has been added.
void | addTexture (QString, QImage, uint, int)
| The texture with the given name and image has been added.
void | addTexture (QString, QString, uint)
| The texture with the given name and filename has been added.
void | addTexture (QString, QImage, uint)
| The texture with the given name and image has been added.
void | addMultiTexture (QString _textureGroup, QString _name, QString _filename, int _id, int &_textureId)
| The texture with the given name and filename has been added.
void | addMultiTexture (QString _textureGroup, QString _name, QImage _image, int _id, int &_textureId)
| The texture with the given name and image has been added.
void | updateTexture (QString, int)
| Tell the plugins to update the given texture.
void | updateAllTextures ()
| Update all textures in the plugins.
void | updatedTextures (QString, int)
| This Signal is send to the plugins if a texture has been updated.
void | setTextureMode (QString _textureName, QString _mode, int _id)
| A texture mode should be changed.
void | setTextureMode (QString _textureName, QString _mode)
| A texture mode should be changed.
void | switchTexture (QString, int)
| Switch Texture Plugins to a given Mode.
void | switchTexture (QString)
| Switch Texture Plugins to a given Mode.
void | textureChangeImage (QString _textureName, QImage &_image)
| Change the image for a given texture.
void | textureChangeImage (QString _textureName, QImage &_image, int _id)
| Change the image for a given texture.
void | textureGetImage (QString _textureName, QImage &_image)
| fetch texture image
void | textureGetImage (QString _textureName, QImage &_image, int _id)
| fetch texture image
void | textureIndex (QString _textureName, int _id, int &_index)
| get the texture index
void | textureIndexPropertyName (int _id, QString &_propertyName)
| get the texture index property name
void | textureName (int _id, int _textureIndex, QString &_textureName)
| get the texture name
void | textureFilename (int _id, QString _textureName, QString &_textureFilename)
| get the texture's filename
void | getCurrentTexture (int _id, QString &_textureName)
| get current texture
void | getSubTextures (int _id, QString _multiTextureName, QStringList &_subTextures)
| get a multi-texture's sub textures
void | addSelectionEnvironment (QString _modeName, QString _description, QString _icon, QString &_handleName)
| SelectionInterface: This signal is emitted when a new toolbutton should be added.
void | registerType (QString _handleName, DataType _type)
| SelectionInterface: This signal is emitted when a data type should be registered for a selection mode.
void | addPrimitiveType (QString _handleName, QString _name, QString _icon, SelectionInterface::PrimitiveType &_typeHandle)
| SelectionInterface: This signal is emitted when a selection plugin should handle a new primitive type.
void | addCustomSelectionMode (QString _handleName, QString _modeName, QString _description, QString _icon, SelectionInterface::PrimitiveType _associatedTypes, QString &_customIdentifier)
| SelectionInterface: This signal is emitted when a custom selection mode is added.
void | addCustomSelectionMode (QString _handleName, QString _modeName, QString _description, QString _icon, SelectionInterface::PrimitiveType _associatedTypes, QString &_customIdentifier, DataType _objectTypeRestriction)
| Signal send to plugins when whole scene is cleared.
void | addSelectionOperations (QString _handleName, QStringList _operationsList, QString _category, SelectionInterface::PrimitiveType _type)
| SelectionInterface: This signal is used to add non-interactive operations for a specific primitive type.
void | addSelectionParameters (QString _handleName, QWidget *_widget, QString _category, SelectionInterface::PrimitiveType _type)
| SelectionInterface: This signal is used to add interactive selection parameters for a specific primitive type.
void | selectionOperation (QString _operation)
| SelectionInterface: This signal is emitted when a non-interactive operation has been performed.
void | showToggleSelectionMode (QString _handleName, bool _show, SelectionInterface::PrimitiveType _associatedTypes)
| SelectionInterface: This signal is emitted when standard toggle selection is required.
void | showLassoSelectionMode (QString _handleName, bool _show, SelectionInterface::PrimitiveType _associatedTypes)
| SelectionInterface: This signal is emitted when standard lasso selection is required.
void | showVolumeLassoSelectionMode (QString _handleName, bool _show, SelectionInterface::PrimitiveType _associatedTypes)
| SelectionInterface: This signal is emitted when standard volume lasso selection is required.
void | showSurfaceLassoSelectionMode (QString _handleName, bool _show, SelectionInterface::PrimitiveType _associatedTypes)
| SelectionInterface: This signal is emitted when standard surface lasso selection is required.
void | showSphereSelectionMode (QString _handleName, bool _show, SelectionInterface::PrimitiveType _associatedTypes)
| SelectionInterface: This signal is emitted when standard sphere selection is required.
void | showClosestBoundarySelectionMode (QString _handleName, bool _show, SelectionInterface::PrimitiveType _associatedTypes)
| SelectionInterface: This signal is emitted when standard closest boundary selection is required.
void | showFloodFillSelectionMode (QString _handleName, bool _show, SelectionInterface::PrimitiveType _associatedTypes)
| SelectionInterface: This signal is emitted when standard flood fill selection is required.
void | showComponentsSelectionMode (QString _handleName, bool _show, SelectionInterface::PrimitiveType _associatedTypes)
| SelectionInterface: This signal is emitted when standard connected components selection is required.
void | toggleSelection (QMouseEvent *_event, SelectionInterface::PrimitiveType _currentType, bool _deselect)
| SelectionInterface: This signal is emitted when standard toggle selection has been performed.
void | lassoSelection (QMouseEvent *_event, SelectionInterface::PrimitiveType _currentType, bool _deselect)
| SelectionInterface: This signal is emitted when standard lasso selection has been performed.
void | volumeLassoSelection (QMouseEvent *_event, SelectionInterface::PrimitiveType _currentType, bool _deselect)
| SelectionInterface: This signal is emitted when standard volume lasso selection has been performed.
void | surfaceLassoSelection (QMouseEvent *_event, SelectionInterface::PrimitiveType _currentType, bool _deselect)
| SelectionInterface: This signal is emitted when standard surface lasso selection has been performed.
void | sphereSelection (QMouseEvent *_event, double _radius, SelectionInterface::PrimitiveType _currentType, bool _deselect)
| SelectionInterface: This signal is emitted when standard sphere selection has been performed.
void | closestBoundarySelection (QMouseEvent *_event, SelectionInterface::PrimitiveType _currentType, bool _deselect)
| SelectionInterface: This signal is emitted when standard closest boundary selection has been performed.
void | floodFillSelection (QMouseEvent *_event, SelectionInterface::PrimitiveType _currentType, bool _deselect)
| SelectionInterface: This signal is emitted when standard flood fill selection has been performed.
void | componentsSelection (QMouseEvent *_event, SelectionInterface::PrimitiveType _currentType, bool _deselect)
| SelectionInterface: This signal is emitted when standard connected components selection has been performed.
void | customSelection (QMouseEvent *_event, SelectionInterface::PrimitiveType _currentType, QString _customIdentifier, bool _deselect)
| SelectionInterface: This signal is emitted when a custom selection operation has been performed.
void | getActiveDataTypes (SelectionInterface::TypeList &_types)
| SelectionInterface: This signal is emitted when the active (selected) data types should be fetched.
void | getActivePrimitiveType (SelectionInterface::PrimitiveType &_type)
| SelectionInterface: This signal is emitted when the active (selected) primitive type should be fetched.
void | targetObjectsOnly (bool &_targetsOnly)
| SelectionInterface: This signal is emitted if the current target restriction state is requested.
void | loadSelection (const INIFile &_file)
| SelectionInterface: This signal is emitted when a selection should be loaded from a file.
void | saveSelection (INIFile &_file)
| SelectionInterface: This signal is emitted when a selection should be written into a file.
void | registerKeyShortcut (int _key, Qt::KeyboardModifiers _modifiers)
| SelectionInterface: This signal is emitted when a type selection plugin wants to listen to a key event.
void | keyShortcutEvent (int _key, Qt::KeyboardModifiers _modifiers=Qt::NoModifier)
| SelectionInterface: This signal is emitted when a key shortcut has been pressed.
void | iniLoad (INIFile &, int)
| If an ini File is opened, this signal is send to Plugins capable of handling ini files.
void | iniSave (INIFile &_ini, int _id)
| This signal is used to tell the plugins to save the data of _id to the given file.
void | iniSaveOptions (INIFile &_ini)
| This signal is used to tell the plugins to save their current status.
void | iniLoadOptions (INIFile &_ini)
| This signal is used to tell the plugins to load their new status.
void | iniLoadOptionsLast (INIFile &_ini)
| This signal is used to tell the plugins to load their new status after objects are loaded.
void | saveOnExit (INIFile &_ini)
| This signal is emitted before the core deletes its data and exits.
void | createBackup (int _objectid, QString _name, UpdateType _type=UPDATE_ALL)
| Tell backup-plugin to create a backup.
void | createBackup (IdList _objectids, QString _name, std::vector< UpdateType > _types)
| Signal send to plugins when whole scene is cleared.
void | undo (int _objectid)
| Tell backup-plugin to undo/redo.
void | redo (int _objectid)
| Signal send to plugins when whole scene is cleared.
void | undo ()
| Signal send to plugins when whole scene is cleared.
void | redo ()
| Signal send to plugins when whole scene is cleared.
void | aboutToRestore (int _objectId)
| Backup Plugin tells other Plugins that a restore will happen.
void | restored (int _objectId)
| Backup Plugin tells other Plugins that a restore has happened.
void | openedFile (int _id)
| Tell the plugins that a file has been opened ( -> Database)
void | emptyObjectAdded (int _id)
| Tell the plugins that an empty object has been added.
void | pluginsInitialized ()
| Called after all plugins are loaded.
void | pluginsInitialized (QVector< QPair< QString, QString >> const &)
| Called after all plugins are loaded and additionally passes command line plugin options.
void | visibilityChanged (int _id)
| Tell plugins that the visibility of an object has changed.
void | objectPropertiesChanged (int _id)
| Tell plugins that object properties such as object names have been changed.
void | objectDeleted (int)
| Called after an object has been deleted.

## Public Member Functions
| Core ()
| constructor More...
void | init ()
| Second initialization stage. More...
| ~Core ()
| destructor
bool | add_sync_host (const QString &_name)
| Synchronise two viewers.

## Private Slots
void | slotMouseEventIdentify (QMouseEvent *_event)
| Handle Mouse events when in Identifier mode.
void | slotMouseEventLight (QMouseEvent *_event)
| Handle Mouse events when in Light mode.
RPC ( Remote procedure Call) support
void | slotPluginExists (QString _pluginName, bool &_exists)
| Check if a plugin exists. More...
void | slotFunctionExists (QString _pluginName, QString _functionName, bool &_exists)
| Check if a function exists. More...
void | slotCall (QString _pluginName, QString _functionName, bool &_success)
void | slotCall (QString _expression, bool &_success)
void | slotGetValue (QString _expression, QVariant &_result)
Object Manager
void | newObject (int _objectId)
| This slot is called by the object manager when a new object is created.
void | deletedObject (int _objectId)
| This slot is called by the object manager when an object is deleted. More...

## Private Member Functions
bool | checkOpenGLCapabilities ()
| OpenGL capability check. More...
bool | checkLibraryVersions ()
| Checks for library inconsistencies. More...
void | hookUpEventFilter (QWidget *widget)
Signal and Slot processing for Plugins
bool | checkSlot (QObject *_plugin, const char *_slotSignature)
| Check if a plugin has a slot.
bool | checkSignal (QObject *_plugin, const char *_signalSignature)
| Check if a plugin has a signal.

## Private Attributes
int | nextBackupId_
| Id for the next backup.
int | nextBackupGroupId_
| Id for the next backup group.
std::vector< PluginLogger * > | loggers_
| Logger interfaces between plugins and core logger.
std::vector< dataTypes > | supportedDataTypes_
| Type-Plugins.
BaseObject * | objectRoot_
| Pointer to the data rootNode;.
CoreWidget * | coreWidget_
| The main applications widget ( only created in gui mode )
QSplashScreen * | splash_
| SplashScreen, only used in gui mode.
QString | splashMessage_
| Last Splash message;.
QVector< ViewMode * > | viewModes_
| List of available draw modes.
QTimer * | redrawTimer_
| If enabled, this timer will block screen refresh if done more then 30 times per second.
SpinBoxEventFilter | spinBoxEventFilter_
Scenegraph
SeparatorNode * | root_node_scenegraph_
| Scenegraphs root node.
SeparatorNode * | root_node_scenegraph_global_
| Seperator node for global nodes.
SeparatorNode * | core_nodes_
| Separator Node holding all core scenegraph nodes.
SeparatorNode * | dataSeparatorNode_
| Toplevel Nodes for data objects.
SeparatorNode * | dataRootNode_
| Root Node for data objects.
ACG::SceneGraph::MaterialNode * | coordsysMaterialNode_
| Node for coordsys Material.
ACG::SceneGraph::CoordsysNode * | coordsysNode_
| Node for the coordinate system.

## Slots called by the plugins
void | slotVisibilityChanged (int _id)
| Called when a plugin changes the visibility of an object.
void | slotObjectPropertiesChanged (int _id)
| Called by plugins if object properties like names have changed.
void | slotObjectSelectionChanged (int _id)
| Called by Plugins if they changed the active object. More...
void | slotAddPickMode (const std::string &_mode)
| Add a new picking mode to the examiner_widget_.
void | slotAddHiddenPickMode (const std::string &_mode)
| Add a new and invisible picking mode to the examiner_widget_.
void | slotAddTexture (QString _textureName, QString _filename, uint _dimension, int _id)
| Called by a plugin if it creates a texture. More...
void | slotAddTexture (QString _textureName, QImage _image, uint _dimension, int _id)
| Called by a plugin if it creates a texture. More...
void | slotAddTexture (QString _textureName, QString _filename, uint _dimension)
| Called by a plugin if it creates a texture. More...
void | slotAddTexture (QString _textureName, QImage _image, uint _dimension)
| Called by a plugin if it creates a texture. More...
void | slotMultiTextureAdded (QString _textureGroup, QString _name, QString _filename, int _id, int &_textureId)
| Called by a plugin if it creates a multitexture.
void | slotMultiTextureAdded (QString _textureGroup, QString _name, QString _filename, int _id, int *_textureId)
| Called when a plugin changes the visibility of an object.
void | slotMultiTextureAdded (QString _textureGroup, QString _name, QImage _image, int _id, int &_textureId)
| Called by a plugin if it creates a multitexture.
void | slotUpdateTexture (QString _name, int _identifier)
| Tell the plugins to update the given texture. More...
void | slotUpdateAllTextures ()
| Update all textures in the plugins. More...
void | slotTextureUpdated (QString _textureName, int _identifier)
| A Texture has been updated. More...
void | slotSetTextureMode (QString _textureName, QString _mode, int _id)
| A texture mode should be changed. More...
void | slotSetTextureMode (QString _textureName, QString _mode)
| A texture mode should be changed. More...
void | slotSwitchTexture (QString _textureName, int _id)
| Tells Plugins to switch to the given Texture. More...
void | slotSwitchTexture (QString _textureName)
| Tells Plugins to switch to the given Texture. More...
void | slotTextureChangeImage (QString _textureName, QImage &_image)
| Called by plugins if texture image should be changed. More...
void | slotTextureChangeImage (QString _textureName, QImage &_image, int _id)
| Called by plugins if texture image should be changed. More...
void | slotTextureGetImage (QString _textureName, QImage &_image)
| Called by plugins if texture image should be fetched. More...
void | slotTextureGetImage (QString _textureName, QImage &_image, int _id)
| Called by plugins if texture image should be fetched. More...
void | slotTextureIndex (QString _textureName, int _id, int &_index)
| Called by plugins if texture index should be fetched. More...
void | slotTextureIndexPropertyName (int _id, QString &_propertyName)
| Called by plugins if texture index property name should be fetched. More...
void | slotTextureName (int _id, int _textureIndex, QString &_textureName)
| Called by plugins if texture name should be fetched. More...
void | slotTextureFilename (int _id, QString _textureName, QString &_textureFilename)
| Called by plugins if texture name should be fetched. More...
void | slotGetCurrentTexture (int _id, QString &_textureName)
| Called by plugins if current texture should be retrieved. More...
void | slotGetSubTextures (int _id, QString _multiTextureName, QStringList &_subTextures)
| Called by plugins if a multi-texture's sub textures should be fetched. More...
void | slotLoad (QString _filename, DataType _type, int &_id)
| A plugin wants to load a given file. More...
void | slotLoad (QStringList _filenames, IdList _pluginIDs)
| the load widget wants to load a given file More...
void | slotFileOpened (int _id)
| Called when a file has been opened. More...
void | slotEmptyObjectAdded (int _id)
| Called when an empty object has been Added. More...
void | slotAddSelectionEnvironment (QString _modeName, QString _description, QString _icon, QString &_handleName)
| SelectionInterface: Called when a new selection type button should be added to the toolbar.
void | slotRegisterType (QString _handleName, DataType _type)
| SelectionInterface: Called when a data type is added for a specific selection type.
void | slotAddPrimitiveType (QString _handleName, QString _name, QString _icon, SelectionInterface::PrimitiveType &_typeHandle)
| SelectionInterface: Called when a new, non-standard primitive type should be handled.
void | slotAddCustomSelectionMode (QString _handleName, QString _modeName, QString _description, QString _icon, SelectionInterface::PrimitiveType _associatedTypes, QString &_customIdentifier)
| SelectionInterface: Add new selection mode for specified type. More...
void | slotAddCustomSelectionMode (QString _handleName, QString _modeName, QString _description, QString _icon, SelectionInterface::PrimitiveType _associatedTypes, QString &_customIdentifier, DataType _objectTypeRestriction)
| SelectionInterface: Add new selection mode for specified type. More...
void | slotAddSelectionOperations (QString _handleName, QStringList _operationsList, QString _category, SelectionInterface::PrimitiveType _type)
| SelectionInterface: Called in order to add non-interactive operations for a specific primitive type.
void | slotAddSelectionParameters (QString _handleName, QWidget *_widget, QString _category, SelectionInterface::PrimitiveType _type)
| SelectionInterface: Called in order to add interactive parameters for a specific primitive type.
void | slotSelectionOperation (QString _operation)
| SelectionInterface: Called when a non-interactive operation has been performed.
void | slotShowToggleSelectionMode (QString _handleName, bool _show, SelectionInterface::PrimitiveType _associatedTypes)
| SelectionInterface: Provide toggle selection operation for specific selection mode.
void | slotShowLassoSelectionMode (QString _handleName, bool _show, SelectionInterface::PrimitiveType _associatedTypes)
| SelectionInterface: Provide lasso selection operation for specific selection mode.
void | slotShowVolumeLassoSelectionMode (QString _handleName, bool _show, SelectionInterface::PrimitiveType _associatedTypes)
| SelectionInterface: Provide volume lasso selection operation for specific selection mode.
void | slotShowSurfaceLassoSelectionMode (QString _handleName, bool _show, SelectionInterface::PrimitiveType _associatedTypes)
| SelectionInterface: Provide surface lasso selection operation for specific selection mode.
void | slotShowSphereSelectionMode (QString _handleName, bool _show, SelectionInterface::PrimitiveType _associatedTypes)
| SelectionInterface: Provide sphere selection operation for specific selection mode.
void | slotShowClosestBoundarySelectionMode (QString _handleName, bool _show, SelectionInterface::PrimitiveType _associatedTypes)
| SelectionInterface: Provide closest boundary selection operation for specific selection mode.
void | slotShowFloodFillSelectionMode (QString _handleName, bool _show, SelectionInterface::PrimitiveType _associatedTypes)
| SelectionInterface: Provide flood fill selection operation for specific selection mode.
void | slotShowComponentsSelectionMode (QString _handleName, bool _show, SelectionInterface::PrimitiveType _associatedTypes)
| SelectionInterface: Provide connected components selection operation for specific selection mode.
void | slotToggleSelection (QMouseEvent *_event, SelectionInterface::PrimitiveType _currentType, bool _deselect)
| SelectionInterface: Called when toggle selection operation has been performed.
void | slotLassoSelection (QMouseEvent *_event, SelectionInterface::PrimitiveType _currentType, bool _deselect)
| SelectionInterface: Called when lasso selection operation has been performed.
void | slotVolumeLassoSelection (QMouseEvent *_event, SelectionInterface::PrimitiveType _currentType, bool _deselect)
| SelectionInterface: Called when volume lasso selection operation has been performed.
void | slotSurfaceLassoSelection (QMouseEvent *_event, SelectionInterface::PrimitiveType _currentType, bool _deselect)
| SelectionInterface: Called when surface lasso selection operation has been performed.
void | slotSphereSelection (QMouseEvent *_event, double _radius, SelectionInterface::PrimitiveType _currentType, bool _deselect)
| SelectionInterface: Called when sphere selection operation has been performed.
void | slotClosestBoundarySelection (QMouseEvent *_event, SelectionInterface::PrimitiveType _currentType, bool _deselect)
| SelectionInterface: Called when closest boundary selection operation has been performed.
void | slotFloodFillSelection (QMouseEvent *_event, SelectionInterface::PrimitiveType _currentType, bool _deselect)
| SelectionInterface: Called when flood fill selection operation has been performed.
void | slotComponentsSelection (QMouseEvent *_event, SelectionInterface::PrimitiveType _currentType, bool _deselect)
| SelectionInterface: Called when connected components selection operation has been performed.
void | slotCustomSelection (QMouseEvent *_event, SelectionInterface::PrimitiveType _currentType, QString _customIdentifier, bool _deselect)
| SelectionInterface: Called when custom selection operation has been performed.
void | slotGetActiveDataTypes (SelectionInterface::TypeList &_types)
| SelectionInterface: Called when active (selected) data types should be fetched.
void | slotGetActivePrimitiveType (SelectionInterface::PrimitiveType &_type)
| SelectionInterface: Called when active primitive type should be fetched.
void | slotTargetObjectsOnly (bool &_targetsOnly)
| SelectionInterface: Called when target restriction state should be fetched.
void | slotLoadSelection (const INIFile &_file)
| SelectionInterface: Called when a selection should be loaded from a file.
void | slotSaveSelection (INIFile &_file)
| SelectionInterface: Called when a selection should be stored into a file.
void | slotRegisterKeyShortcut (int _key, Qt::KeyboardModifiers _modifiers)
| SelectionInterface: Called when a key shortcut is to be registered.
void | slotKeyShortcutEvent (int _key, Qt::KeyboardModifiers _modifiers)
| SelectionInterface: Called when a key event occurred.
void | slotGetAllFilters (QStringList &_list)
| Called when a plugin requests a list of file-filters. More...
void | slotDeleteAllObjects ()
| Called when a plugin wants to delete all objects.
void | slotCrossPluginConnect (QString _pluginName1, const char *_signal, QString _pluginName2, const char *_slot)
| Called to create inter plugin connections.
void | slotCrossPluginConnectQueued (QString _pluginName1, const char *_signal, QString _pluginName2, const char *_slot)
| Called to create inter plugin connections.
void | slotSetRenderer (unsigned int _viewer, QString _rendererName)
| called to switch the renderer for a specific viewer
void | slotGetCurrentRenderer (unsigned int _viewer, QString &_rendererName)
| called to get the currently active renderer renderer for a specific viewer
void | slotObjectUpdated (int _identifier, const UpdateType &_type=UPDATE_ALL)
| Called by the plugins if they changed something in the object list (deleted, added, or other property changes) More...

## Basic functions
std::vector< std::pair< QString, bool > > | commandLineFileNames_
| Vector storing filenames from commandline to be opened after application startup (objects)
std::vector< QString > | commandLineScriptNames_
| Vector storing filenames from commandline to be opened after application startup (script files)
void | commandLineOpen (const QString &_filename, bool _asPolyMesh)
| Load an object from the commandline on application start. More...
void | commandLineScript (const QString &_filename)
| Load a script from the commandline on application start. More...
int | addEmptyObject (DataType _type)
int | loadObject (DataType _type, QString _filename)
| Load object of the given Type with given filename. More...
void | loadObjectFinished (QString _filename)
| Vector storing filenames from commandline to be opened after application startup (objects)
void | resetScenegraph (bool _resetTrackBall)
void | slotExecuteAfterStartup ()
| Executed after loading core completly to load files from commandline. More...
int | loadObject (QString _filename)
| Load a new Object ( this may also be an ini or ofs file ) More...

## Video Stream creation
QTimer | videoTimer_
| Slot called everytime the view is updated.
QTime | lastVideoTime_
| Slot called everytime the view is updated.
int | captureType_
| Slot called everytime the view is updated.
bool | capture_
| Slot called everytime the view is updated.
int | lastWidth_
| Slot called everytime the view is updated.
int | lastHeight_
| Slot called everytime the view is updated.
void | viewUpdated ()
| Slot called everytime the view is updated.
void | captureVideo ()
| Function called for every frame when capturing video.
void | startVideoCapture (QString _baseName, int _fps, bool _captureViewers)
| Start video capturing.
void | stopVideoCapture ()
| Stop video capturing.

## Basic slots
void | slotMouseEvent (QMouseEvent *_event)
| Gets called by examiner widget when mouse is moved in picking mode.
void | slotWheelEvent (QWheelEvent *_event, const std::string &_mode)
| Gets called by examiner widget when Wheel is moved in picking mode.
void | slotAddEmptyObjectMenu ()
| Open the add Empty dialog. More...
void | slotAddEmptyObject (DataType _type, int &_id)
| Slot adding empty object of a given type.
void | slotAddEmptyObject (DataType _type, int *_id)
| Gets called by examiner widget when mouse is moved in picking mode.
void | slotCopyObject (int _oldId, int &_newId)
| Slot copying an object. More...
void | slotExit ()
| Exit Application.
void | slotRecentOpen (QAction *_action)
| Open Recent file.
void | slotGenerateBackup (int _id, QString _name, UpdateType _type)
| Slot for generating type specific backups.
void | addToolbox (QString _name, QWidget *_widget)
| Add a Toolbox from a plugin or from scripting.
void | addToolbox (QString _name, QWidget *_widget, QIcon *_icon)
| Add a Toolbox from a plugin or from scripting (with icon)
void | addToolbox (QString _name, QWidget *_widget, QIcon *_icon, QWidget *_headerAreaWidget)
| Add a Toolbox from a plugin or from scripting (with icon)
QWidget * | getToolbox (QString _pluginName, QString _toolboxName)
void | activateToolbox (QString _pluginName, QString _toolboxName, bool activate)
| expand or collapse a toolbox More...

## IniFile and Options Handling
void | saveOptions ()
| Save the current options to the standard ini file.
void | applyOptions ()
| after ini-files have been loaded and core is up or if options have been changed -> apply Options
void | openIniFile (QString _filename, bool _coreSettings, bool _perPluginSettings, bool _loadObjects)
| Load information from an ini file. More...
void | setupOptions ()
| Get all ini files and set basic paths and options.
void | readGUIOptions (INIFile &_ini)
| Read Options that needs the GUI to be set up completely.
void | readApplicationOptions (INIFile &_ini)
| Get and set Application options from ini file. More...
void | writeApplicationOptions (INIFile &_ini)
| Write Application options to ini file. More...
void | restoreKeyBindings ()
| Restore key assignments from configs files. More...
void | writeIniFile (QString _filename, bool _relativePaths, bool _targetOnly, bool _saveSystemSettings, bool _savePluginSettings, bool _saveObjectInfo, std::map< int, QString > &_fileMapping)
| Write current status to ini file (Application and File Options) More...
void | writeObjFile (QString _filename, bool _relativePaths, bool _targetOnly, std::map< int, QString > &_fileMapping)
| Write current status to obj file (Application and File Options) More...
void | writeOnExit ()
| Called if app is closed and writes all information to ini file.

## Logging
QTextStream * | logStream_
| stream for logging to file
QFile * | logFile_
| logfile
void | scriptLogFunction (QString _output)
| stream for logging to file
void | slotLog (Logtype _type, QString _message)
| Console logger. More...
void | slotLogToFile (Logtype _type, QString _message)
| log to file
void | log (Logtype _type, QString _message)
| Logg with OUT,WARN or ERR as type.
void | log (QString _message)
| Default logging as OUT.
void | scriptLog (QString _message)
| Logging signal for ScriptEngine.
void | externalLog (Logtype _type, QString _message)
| This signal is emitted to send log data to a plugin.

## Plugin Management
int | toolboxindex_
| Index of Plugins toolbox widget.
std::vector< PluginInfo > & | plugins ()
| Index of Plugins toolbox widget.
void | slotShowPlugins ()
| Show Plugins Dialog. More...
void | loadPlugin (const QString &_filename, const bool _silent, QString &_licenseErrors, QObject *_plugin=0)
| Function for loading Plugins. More...
void | slotLoadPlugin ()
| Load Plugins from menu. More...
void | slotBlockPlugin (const QString &_rpcName)
| Function for Blocking Plugins. Blocked plugins will unloaded and not loaded wthin the next starts.
void | slotUnBlockPlugin (const QString &_rpcName)
| Function for UnBlocking Plugins. Plugins will not loaded automatically.
void | loadPlugins ()
| Load all plugins from default plugin directory and from INI-File. More...
void | printPluginLoadLog (const QString &errors, const QString &warnings)
| Print all info collected about plugin during loading.

## Metadata support
void | slotMetadataDeserialized (const QVector< QPair< QString, QString > > &data)
void | genericMetadataDeserialized (QString key, QString value)
void | objectMetadataDeserialized (QString object_name, QString value)
void | objectMetadataDeserializedJson (QString object_name, QJsonDocument value)

## Scripting support
QScriptEngine | scriptEngine_
| Core scripting engine.
std::vector< ScriptingWrapper * > | scriptingWrappers_
| Wrappers for plugin scripting.
QStringList | scriptingFunctions_
| List of all registered scripting functions.
prototypeVec3d | vec3dPrototype_
| Prototype for the Vector type.
prototypeVec4d | vec4dPrototype_
| Prototype for the Vector type.
prototypeDataType | DataTypePrototype_
| Prototype for the DataType.
prototypeMatrix4x4 | matrix4x4Prototype_
| Prototype for the Matrix type.
QList< SlotInfo > | coreSlots_
| Core scripting engine.
QList< SlotInfo > | globalFunctions_
| Core scripting engine.
void | slotScriptInfo (QString _pluginName, QString _functionName)
| Core scripting engine.
void | slotExecuteScript (QString _script)
void | slotExecuteFileScript (QString _filename)
void | slotGetScriptingEngine (QScriptEngine *&_engine)
| Core scripting engine.
void | slotGetAllAvailableFunctions (QStringList &_functions)
| Core scripting engine.
void | slotSetSlotDescription (QString _slotName, QString _slotDescription, QStringList _parameters, QStringList _descriptions)
| set a description for one of the plugin's public slots More...
void | slotSetSlotDescriptionGlobalFunction (QString _functionName, QString _slotDescription, QStringList _parameters, QStringList _descriptions)
| set a description for a global scripting function More...
void | slotScriptError (const QScriptValue &error)
| Core scripting engine.
void | scriptInfo (QString _pluginName, QString _functionName)
| Core scripting engine.
void | executeScript (QString _script)
| Core scripting engine.
void | executeFileScript (QString _filename)
| Core scripting engine.
void | setSlotDescription (QString _slotName, QString _slotDescription, QStringList _parameters, QStringList _descriptions)
| Core scripting engine.
void | createWidget (QString _objectName, QString _uiFilename, bool _show=true)
| Create an script object from a ui file. More...
void | setViewMode (QString _viewMode)
| Set the active ViewMode.
QString | getCurrentViewMode ()
| Get current view mode.
void | setViewModeIcon (QString _mode, QString _iconName)
| Set the icon of a viewMode.
void | moveToolBoxToTop (QString _name)
| Move selected toolbox to top of side area.
void | moveToolBoxToBottom (QString _name)
| Move selected toolbox to bottom of side area.
void | showReducedMenuBar (bool reduced)
| Core scripting engine.
void | executePythonScriptFile (QString _filename)
| Open the given file and execute its contents as a python script. More...
void | executePythonScript (QString _script)
| execute the given string as a python script More...
void | slotGetDescription (QString _function, QString &_fnDescription, QStringList &_parameters, QStringList &_descriptions)
| get available descriptions for a given public slot More...
void | setDescriptions ()
| set the descriptions for scriptable slots of the core

## Scenegraph redraw handling
QTimer * | scenegraphCheckTimer_
| Timer that starts scenegraph check.
QTime * | redrawTime_
| Holds the time since last redraw.
void | checkScenegraphDirty ()
| Called to check if the scenegraph needs to be redrawn. More...

## Process Interface and Controls
QList< JobInfo > | currentJobs
| A job has been started by a plugin.
ProcessManagerWidget * | processManager_
| A job has been started by a plugin.
void | slotStartJob (QString _jobId, QString _description, int _min, int _max, bool _blocking)
| A job has been started by a plugin.
void | slotSetJobState (QString _jobId, int _value)
| A job state has been updated by a plugin.
void | slotSetJobName (QString _jobId, QString _name)
| A job's widget caption has been updated by a plugin.
void | slotSetJobDescription (QString _jobId, QString _text)
| A job's widget's status text has been updated by a plugin.
void | slotCancelJob (QString _jobId)
| A job state has been canceled by a plugin.
void | slotFinishJob (QString _jobId)
| A job state has been finished by a plugin.
void | slotJobCancelRequested (QString _jobId)
| Called by dialogs if cancel button is pressed.
void | jobCanceled (QString _jobId)
| A job has been started by a plugin.
bool | getJob (QString _jobId, int &_index)
| Find a job in the jobslist.

## Detailed Description

Core Widget of the Application

Definition at line 132 of file Core.hh.

## Constructor & Destructor Documentation

## ◆ Core()

Core::Core | ( |  | ) |

constructor

Constuctor for the Core Widget ( This is stage 1 , call init for stage 2)

Initialization is working the following way:

- Setup basic paths
- Get Options from Option files ( While skipping the OpenFiles Sections as Core is not running )
- Jump back ( Stage two is done by calling init from main ) so CALL init!!
- This Two stage system allows using commandline options which override Option Files

Definition at line 108 of file Core.cc.

## Member Function Documentation

## ◆ activateToolbox

void Core::activateToolbox | ( | QString | _pluginName,
|  | QString | _toolboxName,
|  | bool | activate
| ) |  |
| slot

expand or collapse a toolbox

Parameters

  _pluginName | To which plugin does the toolbox belong
  _toolboxName | Name of the toolbox
  activate | Expand or collapse?

Definition at line 248 of file scripting.cc.

## ◆ addEmptyObject()

int Core::addEmptyObject | ( | DataType | _type | ) |

Add an empty Object of the given Type

Returns
  id of the new object or -1 if unsupported

Definition at line 477 of file openFunctions.cc.

## ◆ addViewModeContextMenus

void Core::addViewModeContextMenus | ( | QString | _modeName,
|  | QString | _contextMenuList
| ) |  |
| slot

Scripting function to set context menus in a view mode.

Parameters

  _modeName | Name of the View Mode
  _contextMenuList | ; separated list of context menus in the view mode

Definition at line 205 of file scripting.cc.

## ◆ addViewModeIcon

void Core::addViewModeIcon | ( | QString | _modeName,
|  | QString | _iconName
| ) |  |
| slot

Scripting function to set an icon for a view mode.

Parameters

  _modeName | Name of the View Mode
  _iconName | Name of the Icon File. Will be taken from OpenFlippers Icon directory

Definition at line 211 of file scripting.cc.

## ◆ addViewModeToolbars

void Core::addViewModeToolbars | ( | QString | _modeName,
|  | QString | _toolbarList
| ) |  |
| slot

Scripting function to set toolbars in a view mode.

Parameters

  _modeName | Name of the View Mode
  _toolbarList | ; separated list of toolbars in the view mode

Definition at line 197 of file scripting.cc.

## ◆ addViewModeToolboxes

void Core::addViewModeToolboxes | ( | QString | _modeName,
|  | QString | _toolboxList
| ) |  |
| slot

Scripting function to set toolboxes in a view mode.

Parameters

  _modeName | Name of the View Mode
  _toolboxList | ; separated list of toolboxes in the view mode

Definition at line 189 of file scripting.cc.

## ◆ checkLibraryVersions()

bool Core::checkLibraryVersions | ( |  | ) |
| private

Checks for library inconsistencies.

Checks if the used libraries are consistent

Definition at line 1916 of file Core.cc.

## ◆ checkOpenGLCapabilities()

bool Core::checkOpenGLCapabilities | ( |  | ) |
| private

OpenGL capability check.

Checks if the OpenGL Capabilities of the graphics card are sufficient and prints an error message if not.

Definition at line 1980 of file Core.cc.

## ◆ checkScenegraphDirty

void Core::checkScenegraphDirty | ( |  | ) |
| private slot

Called to check if the scenegraph needs to be redrawn.

Check if scenegraph is dirty and initiate redraw

Definition at line 1011 of file Core.cc.

## ◆ clearAllComments

void Core::clearAllComments | ( | int | objId | ) |
| slot

Called when a plugin requests an update in the viewer.

Update the view in the examiner widget

Definition at line 1876 of file Core.cc.

## ◆ clearObjectComment

void Core::clearObjectComment | ( | int | objId,
|  | QString | key
| ) |  |
| slot

Called when a plugin requests an update in the viewer.

Update the view in the examiner widget

Definition at line 1863 of file Core.cc.

## ◆ commandLineOpen()

void Core::commandLineOpen | ( | const QString & | _filename,
|  | bool | _asPolyMesh
| ) |  |

Load an object from the commandline on application start.

This function is called before the event queue is executed. The filename and parameters are stored. After the event queue is started, all files in this list will be opened. This is necessary as the event queue has to run to schedule the events emitted during open operations.

Parameters

  _filename | filename of the file to be opened. If it does not contain a full path, the current path will be prepended.
  _asPolyMesh | Load as a polymesh ( yes/no)

Definition at line 98 of file openFunctions.cc.

## ◆ commandLineScript()

void Core::commandLineScript | ( | const QString & | _filename | ) |

Load a script from the commandline on application start.

This function is called before the event queue is executed. The filename is stored. After the event queue is started, all files in this list will be opened. This is necessary as the event queue has to run to schedule the events emitted during open operations.

Parameters

  _filename | filename of the script to be opened. If it does not contain a full path, the current path will be prepended.

Definition at line 113 of file openFunctions.cc.

## ◆ createWidget

void Core::createWidget | ( | QString | _objectName,
|  | QString | _uiFilename,
|  | bool | _show = `true`
| ) |  |
| slot

Create an script object from a ui file.

This function will load an ui file, set up a qwidget from that and makes it available under _objectName for scripting.

Parameters

  _objectName | The name in scripting environment used for the new object
  _uiFilename | ui file to load

Definition at line 91 of file scripting.cc.

## ◆ deletedObject

void Core::deletedObject | ( | int | _objectId | ) |
| private slot

This slot is called by the object manager when an object is deleted.

This slot is called by the object manager when a object is deleted.

Definition at line 514 of file PluginCommunication.cc.

## ◆ deserializeMaterialProperties

void Core::deserializeMaterialProperties | ( | int | _objId,
|  | QString | _props
| ) |  |
| slot

Serialize material properties.

Parameters

  _objId | Id of the object where the material should be deserialized into
  _props | A QString containing the serialized material

Definition at line 1811 of file Core.cc.

## ◆ executePythonScript

void Core::executePythonScript | ( | QString | _script | ) |
| slot

execute the given string as a python script

Parameters

  _script | Python script

Definition at line 441 of file scripting.cc.

## ◆ executePythonScriptFile

void Core::executePythonScriptFile | ( | QString | _filename | ) |
| slot

Open the given file and execute its contents as a python script.

Parameters

  _filename | Name of the python script

Definition at line 417 of file scripting.cc.

## ◆ exitFailure

void Core::exitFailure | ( |  | ) |
| slot

Aborts the application with an error code.

Use this function in unit tests, if you detected a failure. Therefore the test functions will recognize that something went wrong.

Definition at line 1268 of file Core.cc.

## ◆ getToolbox

QWidget * Core::getToolbox | ( | QString | _pluginName,
|  | QString | _toolboxName
| ) |  |
| slot

Get a toolbox.

Parameters

  _pluginName | The plugin which the requested toolbox belongs to.
  _toolboxName | The name of the requested toolbox.

Returns
  A pointer to the requested toolbox widget if it was found, nullptr, otherwise.

Definition at line 230 of file scripting.cc.

## ◆ init()

void Core::init | ( |  | ) |

Second initialization stage.

This Stage does the following :

- Create the Core GUI Elements (Examiner, Toolbox,...)
- Create the MenuBar
- load the Plugins
- connect the Mouse slots
- Load all ini files (This includes the Global Option files)

Skip all signals for function calls

Definition at line 192 of file Core.cc.

## ◆ loadObject [1/3]

int Core::loadObject | ( | QString | _filename | ) |
| slot

Load a new Object ( this may also be an ini or ofs file )

This function tries to get the type of data to be loaded from the filename and then load the file.

Parameters

  _filename | Filename of the data

Returns
  id of object otherwise -1

Todo:
  Check if this function is ok. It should check all plugins for the given files and do not depend on Triangle meshes only! Rewrite function to get the plugin only and then open the file. So iterate over all plugins and find the matching ones. open it with this plugin.

Definition at line 245 of file openFunctions.cc.

## ◆ loadObject() [2/3]

int Core::loadObject | ( | DataType | _type,
|  | QString | _filename
| ) |  |

Load object of the given Type with given filename.

Function for loading a given file.

This function should not be used anymore.
The extension is now used to check for the plugin handling the given types.

Returns
  id of the new object or -1 if unsupported

Todo:
  this function has to be checked. test for the plugin which can handle the given file and then use it.

Definition at line 351 of file openFunctions.cc.

## ◆ loadObject [3/3]

void Core::loadObject | ( |  | ) |
| slot

Open Load Widget.

Open Load-Object Widget.

Definition at line 883 of file openFunctions.cc.

## ◆ loadPlugin

void Core::loadPlugin | ( | const QString & | _filename,
|  | const bool | _silent,
|  | QString & | _licenseErrors,
|  | QObject * | _plugin = `0`
| ) |  |
| private slot

Function for loading Plugins.

Load a Plugin with given filename.

Parameters

  _filename | complete path + filename of the plugin
  _silent | if 'true': user isn't asked what to do if a plugin is already loaded
  _licenseErrors | String will be epty when no license issues occured, otherwise it contains the required information for obtaining a license
  _plugin | You can provide a preloaded plugin here. If this is 0 the filename will be used to load the plugin.

Skip all signals for function calls

Definition at line 710 of file PluginLoader.cc.

## ◆ loadPlugins()

void Core::loadPlugins | ( |  | ) |
| private

Load all plugins from default plugin directory and from INI-File.

Load plugins from dir Plugins. The plugin information gets stored, toolbox and menu entries are created and the required signals and slots are connected.

Definition at line 268 of file PluginLoader.cc.

## ◆ loadSettings [1/2]

void Core::loadSettings | ( |  | ) |
| slot

Load status from file.

Load settings from file.

Definition at line 906 of file openFunctions.cc.

## ◆ loadSettings [2/2]

void Core::loadSettings | ( | QString | _filename | ) |
| slot

Load status from file.

Load settings from file.

Definition at line 987 of file openFunctions.cc.

## ◆ openIniFile

void Core::openIniFile | ( | QString | _filename,
|  | bool | _coreSettings,
|  | bool | _perPluginSettings,
|  | bool | _loadObjects
| ) |  |
| slot

Load information from an ini file.

This function will open an ini file and load the information in it.

Parameters

  _filename | Name of the ini file
  _coreSettings | Load core settings from the file
  _perPluginSettings | Load per plugin settings from the file
  _loadObjects | Load objects defined in the ini file

Definition at line 400 of file ParseIni.cc.

## ◆ readApplicationOptions()

void Core::readApplicationOptions | ( | INIFile & | _ini | ) |
| private

Get and set Application options from ini file.

Load the standard options from the given Ini File

Parameters

  _ini | Inifile to use

Definition at line 72 of file ParseIni.cc.

## ◆ resetScenegraph

void Core::resetScenegraph | ( | bool | _resetTrackBall | ) |
| private slot

Do a reset of the scenegraph (bounding box update,...)

Parameters

  _resetTrackBall | Should the rotation center of the trackball be reset to the scene center?

Definition at line 62 of file openFunctions.cc.

## ◆ restoreKeyBindings()

void Core::restoreKeyBindings | ( |  | ) |
| private

Restore key assignments from configs files.

restore key Assignments that were saved in config files

Definition at line 222 of file optionHandling.cc.

## ◆ saveAllObjects

void Core::saveAllObjects | ( |  | ) |
| slot

Slot for saving objects from Menu.

Save changes for all target objects (slot is called from CoreWidget's File-Menu)

Definition at line 266 of file saveFunctions.cc.

## ◆ saveAllObjectsTo

void Core::saveAllObjectsTo | ( |  | ) |
| slot

Slot for saving objects to a new location.

Save all target objects under new name (slot is called from CoreWidget's File-Menu)

Definition at line 292 of file saveFunctions.cc.

## ◆ saveObject [1/2]

bool Core::saveObject | ( | int | _id,
|  | QString | _filename
| ) |  |
| slot

Save an object.

Save object with given id

Parameters

  _id | id of the object

Get object with given id, find a plugin to save dataType, save

Note
  Existing files will be overwritten

Parameters

  _id | Id of the object that should be saved
  _filename | Filename to save to

Returns
  Successful

Definition at line 65 of file saveFunctions.cc.

## ◆ saveObject [2/2]

void Core::saveObject | ( | int | _id,
|  | QString | _filename,
|  | int | _pluginID
| ) |  |
| slot

Save an object get object with given id, find a plugin to save dataType, save! (existing files will be overwritten)

Definition at line 124 of file saveFunctions.cc.

## ◆ saveObjects

void Core::saveObjects | ( | IdList | _ids,
|  | QString | _filename,
|  | int | _pluginID
| ) |  |
| slot

Save multiple objects to one file get object with given id, find a plugin to save dataType, save! (existing files will be overwritten)

Definition at line 165 of file saveFunctions.cc.

## ◆ saveObjectsTo

bool Core::saveObjectsTo | ( | IdList | _ids,
|  | QString | _filename
| ) |  |
| slot

Save multiple objects to a new location Show the save-widget to determine a filename, the widget calls slotSave to save the objects

Definition at line 239 of file saveFunctions.cc.

## ◆ saveObjectTo

bool Core::saveObjectTo | ( | int | _id,
|  | QString | _filename
| ) |  |
| slot

Show dialog for saving an object to a new location

Parameters

  _id | id of the object
  _filename | current filename of the object

Save an object to a new location Show the save-widget to determine a filename, the widget calls slotSave to save the object

Definition at line 211 of file saveFunctions.cc.

## ◆ saveSettings

void Core::saveSettings | ( |  | ) |
| slot

Save current status to a settings file. Solicit file name through dialog.

Save Settings (slot is called from CoreWidget's File-Menu)

Definition at line 53 of file saveSettings.cc.

## ◆ serializeMaterialProperties

QString Core::serializeMaterialProperties | ( | int | _objId | ) |
| slot

Serialize material properties.

Parameters

  _objId | Id of the object where the material should be serialized

Returns
  A Qstring containing the serialized material

Definition at line 1830 of file Core.cc.

## ◆ setObjectComment

void Core::setObjectComment | ( | int | objId,
|  | QString | key,
|  | QString | comment
| ) |  |
| slot

Called when a plugin requests an update in the viewer.

Update the view in the examiner widget

Definition at line 1850 of file Core.cc.

## ◆ setToolBoxActive

void Core::setToolBoxActive | ( | QString | _toolBoxName,
|  | bool | _active
| ) |  |
| slot

Scripting function to activate or deactivate a toolbox.

Parameters

  _toolBoxName | Name of the toolbox to manipulate
  _active | Activate or deactivate

Definition at line 303 of file scripting.cc.

## ◆ setToolBoxSide

void Core::setToolBoxSide | ( | QString | _side | ) |
| slot

Scripting function to set the side of the main window on which the toolbox should be displayed.

Parameters

  _side | The desired side (either "left" or "right")

Definition at line 217 of file scripting.cc.

## ◆ setView

void Core::setView | ( | QString | view | ) |
| slot

Called when a plugin requests an update in the viewer.

Update the view in the examiner widget

Definition at line 320 of file scripting.cc.

## ◆ setViewAndWindowGeometry

void Core::setViewAndWindowGeometry | ( | QString | view | ) |
| slot

Called when a plugin requests an update in the viewer.

Update the view in the examiner widget

Definition at line 324 of file scripting.cc.

## ◆ slotAddCustomSelectionMode [1/2]

void Core::slotAddCustomSelectionMode | ( | QString | _handleName,
|  | QString | _modeName,
|  | QString | _description,
|  | QString | _icon,
|  | SelectionInterface::PrimitiveType | _associatedTypes,
|  | QString & | _customIdentifier
| ) |  |
| private slot

SelectionInterface: Add new selection mode for specified type.

Parameters

  _handleName | Handle of the selection mode
  _modeName | User visible name of the selection mode
  _description | Description of the mode
  _icon | Icon displayed in the selection toolbar
  _associatedTypes | primitive types supported by this mode
  _customIdentifier | Identifier of this mode

Definition at line 71 of file SelectionCommunication.cc.

## ◆ slotAddCustomSelectionMode [2/2]

void Core::slotAddCustomSelectionMode | ( | QString | _handleName,
|  | QString | _modeName,
|  | QString | _description,
|  | QString | _icon,
|  | SelectionInterface::PrimitiveType | _associatedTypes,
|  | QString & | _customIdentifier,
|  | DataType | _objectTypeRestriction
| ) |  |
| private slot

SelectionInterface: Add new selection mode for specified type.

Parameters

  _handleName | Handle of the selection mode
  _modeName | User visible name of the selection mode
  _description | Description of the mode
  _icon | Icon displayed in the selection toolbar
  _associatedTypes | primitive types supported by this mode
  _customIdentifier | Identifier of this mode
  _objectTypeRestriction | Object types supported by this mode

Definition at line 76 of file SelectionCommunication.cc.

## ◆ slotAddEmptyObjectMenu

void Core::slotAddEmptyObjectMenu | ( |  | ) |
| private slot

Open the add Empty dialog.

Opens AddEmpty-Object widget.

This slot shows the addEmpty dialog which is used to add empty objects of supported dataTypes

Definition at line 799 of file openFunctions.cc.

## ◆ slotAddTexture [1/4]

void Core::slotAddTexture | ( | QString | _textureName,
|  | QString | _filename,
|  | uint | _dimension,
|  | int | _id
| ) |  |
| private slot

Called by a plugin if it creates a texture.

Called by a plugin if it created a texture. The information is passed to all plugins. If a texture control plugin is available it has to react on the signal.
See in the documentation of the texture plugin interfaces for further detail.

Definition at line 180 of file PluginCommunication.cc.

## ◆ slotAddTexture [2/4]

void Core::slotAddTexture | ( | QString | _textureName,
|  | QImage | _image,
|  | uint | _dimension,
|  | int | _id
| ) |  |
| private slot

Called by a plugin if it creates a texture.

Called by a plugin if it created a texture. The information is passed to all plugins. If a texture control plugin is available it has to react on the signal.
See in the documentation of the texture plugin interfaces for further detail.

Definition at line 206 of file PluginCommunication.cc.

## ◆ slotAddTexture [3/4]

void Core::slotAddTexture | ( | QString | _textureName,
|  | QString | _filename,
|  | uint | _dimension
| ) |  |
| private slot

Called by a plugin if it creates a texture.

Called by a plugin if it created a texture. The information is passed to all plugins. If a texture control plugin is available it has to react on the signal.
See in the documentation of the texture plugin interfaces for further detail.

Definition at line 232 of file PluginCommunication.cc.

## ◆ slotAddTexture [4/4]

void Core::slotAddTexture | ( | QString | _textureName,
|  | QImage | _image,
|  | uint | _dimension
| ) |  |
| private slot

Called by a plugin if it creates a texture.

Called by a plugin if it created a texture. The information is passed to all plugins. If a texture control plugin is available it has to react on the signal.
See in the documentation of the texture plugin interfaces for further detail.

Definition at line 258 of file PluginCommunication.cc.

## ◆ slotCall [1/2]

void Core::slotCall | ( | QString | _pluginName,
|  | QString | _functionName,
|  | bool & | _success
| ) |  |
| private slot

This slot executes a function of a plugin. If it does not exist, _success will be false

Parameters

  _pluginName | Plugin where the function is implemented
  _functionName | name of the function ( Standard name, no parameters allowed!)
  _success | successfull execution?

Definition at line 94 of file RPC.cc.

## ◆ slotCall [2/2]

void Core::slotCall | ( | QString | _expression,
|  | bool & | _success
| ) |  |
| private slot

This slot executes the given expression. No checks are performed if the remote function is available.

Parameters

  _expression | command to execute
  _success | successfull execution?

Definition at line 131 of file RPC.cc.

## ◆ slotCopyObject

void Core::slotCopyObject | ( | int | _oldId,
|  | int & | _newId
| ) |  |
| private slot

Slot copying an object.

Slot creating a copy of an existing object.

Definition at line 527 of file openFunctions.cc.

## ◆ slotEmptyObjectAdded

void Core::slotEmptyObjectAdded | ( | int | _id | ) |
| private slot

Called when an empty object has been Added.

Slot gets called after a file-plugin has opened an object.

Todo:
  : set a default path for new objects

Definition at line 762 of file openFunctions.cc.

## ◆ slotExecuteAfterStartup

void Core::slotExecuteAfterStartup | ( |  | ) |
| private slot

Executed after loading core completly to load files from commandline.

This slot is automatically called after application startup. All files from the commandline will be loaded by this slot. This is required as the core and the event queue need to be running to emit the required signals to the plugins.

Definition at line 128 of file openFunctions.cc.

## ◆ slotExecuteFileScript

void Core::slotExecuteFileScript | ( | QString | _filename | ) |
| private slot

Core slot, executes the given file as a script via scripting plugin

Parameters

  _filename | Filename of the script

Definition at line 75 of file scripting.cc.

## ◆ slotExecuteScript

void Core::slotExecuteScript | ( | QString | _script | ) |
| private slot

Core slot, executes the given script text via scripting plugin

Parameters

  _script | Script as QString

Definition at line 71 of file scripting.cc.

## ◆ slotFileOpened

void Core::slotFileOpened | ( | int | _id | ) |
| private slot

Called when a file has been opened.

Slot gets called after a file-plugin has opened an object.

Definition at line 696 of file openFunctions.cc.

## ◆ slotFunctionExists

void Core::slotFunctionExists | ( | QString | _pluginName,
|  | QString | _functionName,
|  | bool & | _exists
| ) |  |
| private slot

Check if a function exists.

Parameters

  _pluginName | Name of the plugin to check
  _functionName | Name of the function inside the plugin
  _exists | Returns if the function was found in the plugin

Definition at line 75 of file RPC.cc.

## ◆ slotGetAllFilters

void Core::slotGetAllFilters | ( | QStringList & | _list | ) |
| private slot

Called when a plugin requests a list of file-filters.

This function collects all available load filters from the file Plugins. It is normally called via the Load/Save interface ( LoadSaveInterface ).

Parameters

  _list | Returns a list of all available file load filters

Todo:
  check why the supported Type is used here!

Definition at line 88 of file openFunctions.cc.

## ◆ slotGetCurrentTexture

void Core::slotGetCurrentTexture | ( | int | _id,
|  | QString & | _textureName
| ) |  |
| private slot

Called by plugins if current texture should be retrieved.

Called by plugins if current texture name should be returned

Definition at line 483 of file PluginCommunication.cc.

## ◆ slotGetDescription

void Core::slotGetDescription | ( | QString | _function,
|  | QString & | _fnDescription,
|  | QStringList & | _parameters,
|  | QStringList & | _descriptions
| ) |  |
| slot

get available descriptions for a given public slot

get available Descriptions for a scriptable slot

Definition at line 1385 of file Core.cc.

## ◆ slotGetSubTextures

void Core::slotGetSubTextures | ( | int | _id,
|  | QString | _multiTextureName,
|  | QStringList & | _subTextures
| ) |  |
| private slot

Called by plugins if a multi-texture's sub textures should be fetched.

Called by plugins if texture image should be fetched

Definition at line 489 of file PluginCommunication.cc.

## ◆ slotGetValue

void Core::slotGetValue | ( | QString | _expression,
|  | QVariant & | _result
| ) |  |
| private slot

This slot executes the given expression and returns the result No checks are performed if the remote function is available. if an error occurs the result contains an invalid QVariant

ex. getValue("databaseplugin.tableExists(\"meshes")", result) ) result.toBool() == true

Parameters

  _expression | command to execute
  _result | The return value of the command

Definition at line 146 of file RPC.cc.

## ◆ slotLoad [1/2]

void Core::slotLoad | ( | QString | _filename,
|  | DataType | _type,
|  | int & | _id
| ) |  |
| private slot

A plugin wants to load a given file.

Slot for loading a given file.

Definition at line 685 of file openFunctions.cc.

## ◆ slotLoad [2/2]

void Core::slotLoad | ( | QStringList | _filenames,
|  | IdList | _pluginIDs
| ) |  |
| private slot

the load widget wants to load a given file

Function for loading multiple files.

Definition at line 568 of file openFunctions.cc.

## ◆ slotLoadPlugin

void Core::slotLoadPlugin | ( |  | ) |
| private slot

Load Plugins from menu.

slot for loading Plugins

Definition at line 563 of file PluginLoader.cc.

## ◆ slotLog

void Core::slotLog | ( | Logtype | _type,
|  | QString | _message
| ) |  |
| private slot

Console logger.

Slot writing everything to the Logger widget.

This slot has to be called by all loggers. It is used to serialize and color the Output.

Parameters

  _type | Logtype (defines the color of the output)
  _message | The message for output

Definition at line 91 of file Logging.cc.

## ◆ slotObjectSelectionChanged

void Core::slotObjectSelectionChanged | ( | int | _id | ) |
| private slot

Called by Plugins if they changed the active object.

This function is called if the active object has changed. The information is passed to all plugins.

Definition at line 156 of file PluginCommunication.cc.

## ◆ slotObjectUpdated

void Core::slotObjectUpdated | ( | int | _identifier,
|  | const UpdateType & | _type = `UPDATE_ALL`
| ) |  |
| slot

Called by the plugins if they changed something in the object list (deleted, added, or other property changes)

Handle object updates by plugins.

This function is called by a plugin if it changed something in the object list (source,target, or other properties ). The information is passed to all plugins.

Parameters

  _identifier | Id of the updated object
  _type | What part of the object has been updated

Definition at line 75 of file PluginCommunication.cc.

## ◆ slotPluginExists

void Core::slotPluginExists | ( | QString | _pluginName,
|  | bool & | _exists
| ) |  |
| private slot

Check if a plugin exists.

Parameters

  _pluginName | Name of the plugin to check
  _exists | Returns if the function was found in the plugin

Definition at line 63 of file RPC.cc.

## ◆ slotSetSlotDescription

void Core::slotSetSlotDescription | ( | QString | _slotName,
|  | QString | _slotDescription,
|  | QStringList | _parameters,
|  | QStringList | _descriptions
| ) |  |
| private slot

set a description for one of the plugin's public slots

set descriptions for a scriptable slot

Definition at line 1333 of file Core.cc.

## ◆ slotSetSlotDescriptionGlobalFunction

void Core::slotSetSlotDescriptionGlobalFunction | ( | QString | _functionName,
|  | QString | _slotDescription,
|  | QStringList | _parameters,
|  | QStringList | _descriptions
| ) |  |
| private slot

set a description for a global scripting function

set descriptions for a scriptable slot

Definition at line 1372 of file Core.cc.

## ◆ slotSetTextureMode [1/2]

void Core::slotSetTextureMode | ( | QString | _textureName,
|  | QString | _mode,
|  | int | _id
| ) |  |
| private slot

A texture mode should be changed.

Called by a plugin if the parameters of a texture should be changed. The information is passed to all plugins. A Texturecontrol plugin should react on this event.
See in the documentation of the texture plugin interfaces for further detail.

Definition at line 358 of file PluginCommunication.cc.

## ◆ slotSetTextureMode [2/2]

void Core::slotSetTextureMode | ( | QString | _textureName,
|  | QString | _mode
| ) |  |
| private slot

A texture mode should be changed.

Called by a plugin if the parameters of a texture should be changed. The information is passed to all plugins. A Texturecontrol plugin should react on this event.
See in the documentation of the texture plugin interfaces for further detail.

Definition at line 375 of file PluginCommunication.cc.

## ◆ slotShowPlugins

void Core::slotShowPlugins | ( |  | ) |
| private slot

Show Plugins Dialog.

slot for showing loaded Plugins

Definition at line 648 of file PluginLoader.cc.

## ◆ slotSwitchTexture [1/2]

void Core::slotSwitchTexture | ( | QString | _textureName,
|  | int | _id
| ) |  |
| private slot

Tells Plugins to switch to the given Texture.

Called by plugins if texture mode should be switched

Definition at line 406 of file PluginCommunication.cc.

## ◆ slotSwitchTexture [2/2]

void Core::slotSwitchTexture | ( | QString | _textureName | ) |
| private slot

Tells Plugins to switch to the given Texture.

Called by plugins if texture mode should be switched

Definition at line 420 of file PluginCommunication.cc.

## ◆ slotTextureChangeImage [1/2]

void Core::slotTextureChangeImage | ( | QString | _textureName,
|  | QImage & | _image
| ) |  |
| private slot

Called by plugins if texture image should be changed.

Called by plugins if texture image should be changed

Definition at line 435 of file PluginCommunication.cc.

## ◆ slotTextureChangeImage [2/2]

void Core::slotTextureChangeImage | ( | QString | _textureName,
|  | QImage & | _image,
|  | int | _id
| ) |  |
| private slot

Called by plugins if texture image should be changed.

Called by plugins if texture image should be changed

Definition at line 441 of file PluginCommunication.cc.

## ◆ slotTextureFilename

void Core::slotTextureFilename | ( | int | _id,
|  | QString | _textureName,
|  | QString & | _textureFilename
| ) |  |
| private slot

Called by plugins if texture name should be fetched.

Called by plugins if texture filename should be fetched

Definition at line 477 of file PluginCommunication.cc.

## ◆ slotTextureGetImage [1/2]

void Core::slotTextureGetImage | ( | QString | _textureName,
|  | QImage & | _image
| ) |  |
| private slot

Called by plugins if texture image should be fetched.

Called by plugins if texture image should be fetched

Definition at line 447 of file PluginCommunication.cc.

## ◆ slotTextureGetImage [2/2]

void Core::slotTextureGetImage | ( | QString | _textureName,
|  | QImage & | _image,
|  | int | _id
| ) |  |
| private slot

Called by plugins if texture image should be fetched.

Called by plugins if texture image should be fetched

Definition at line 453 of file PluginCommunication.cc.

## ◆ slotTextureIndex

void Core::slotTextureIndex | ( | QString | _textureName,
|  | int | _id,
|  | int & | _index
| ) |  |
| private slot

Called by plugins if texture index should be fetched.

Called by plugins if texture index should be fetched

Definition at line 459 of file PluginCommunication.cc.

## ◆ slotTextureIndexPropertyName

void Core::slotTextureIndexPropertyName | ( | int | _id,
|  | QString & | _propertyName
| ) |  |
| private slot

Called by plugins if texture index property name should be fetched.

Called by plugins if texture index property name should be fetched

Definition at line 465 of file PluginCommunication.cc.

## ◆ slotTextureName

void Core::slotTextureName | ( | int | _id,
|  | int | _textureIndex,
|  | QString & | _textureName
| ) |  |
| private slot

Called by plugins if texture name should be fetched.

Called by plugins if texture name should be fetched

Definition at line 471 of file PluginCommunication.cc.

## ◆ slotTextureUpdated

void Core::slotTextureUpdated | ( | QString | _textureName,
|  | int | _identifier
| ) |  |
| private slot

A Texture has been updated.

Called by a plugin if it updated a texture. The information is passed to all plugins. If a texture control plugin is available it has to react on the signal and update the visualization of the texture.
See in the documentation of the texture plugin interfaces for further detail.

Definition at line 392 of file PluginCommunication.cc.

## ◆ slotUpdateAllTextures

void Core::slotUpdateAllTextures | ( |  | ) |
| private slot

Update all textures in the plugins.

Called by a plugin if all textures should be updated. The information is passed to all plugins. All plugins providing textures should react on this event.
See in the documentation of the texture plugin interfaces for further detail.

Definition at line 351 of file PluginCommunication.cc.

## ◆ slotUpdateTexture

void Core::slotUpdateTexture | ( | QString | _name,
|  | int | _identifier
| ) |  |
| private slot

Tell the plugins to update the given texture.

Called by a plugin if a texture has to be updated. The information is passed to all plugins. The Plugin providing the given Texture should react on this event.
See in the documentation of the texture plugin interfaces for further detail.

Definition at line 284 of file PluginCommunication.cc.

## ◆ snapshot

void Core::snapshot | ( | unsigned int | _viewerId = `0`,
|  | int | _width = `0`,
|  | int | _height = `0`,
|  | bool | _alpha = `false`,
|  | bool | _hideCoordsys = `false`,
|  | int | _numSamples = `1`
| ) |  |
| slot

Trigger a snapshot and increase the snapshot counter. Save snapshot to file determined by snapshotBaseFileName() and the current snapshot counter. The back buffer will be saved. The id of the current viewer is 0 (default).

Definition at line 1494 of file Core.cc.

## ◆ snapshotBaseFileName

void Core::snapshotBaseFileName | ( | QString | _fname,
|  | unsigned int | _viewerId = `0`
| ) |  |
| slot

set the baseFilename for snapshots (a counter is automatically increased when snapshot() is called)

Definition at line 1454 of file Core.cc.

## ◆ updateView

void Core::updateView | ( |  | ) |
| slot

Called when a plugin requests an update in the viewer.

Update the view in the examiner widget

Definition at line 943 of file Core.cc.

## ◆ writeApplicationOptions()

void Core::writeApplicationOptions | ( | INIFile & | _ini | ) |
| private

Write Application options to ini file.

Write the standard options to the given Ini File

Parameters

  _ini | Inifile to use

Definition at line 285 of file ParseIni.cc.

## ◆ writeIniFile()

void Core::writeIniFile | ( | QString | _filename,
|  | bool | _relativePaths,
|  | bool | _targetOnly,
|  | bool | _saveSystemSettings,
|  | bool | _savePluginSettings,
|  | bool | _saveObjectInfo,
|  | std::map< int, QString > & | _fileMapping
| ) |  |
| private

Write current status to ini file (Application and File Options)

Writes the complete status to an ini file ( All open objects and their Information )

Parameters

  _filename | Filename of the ini file to write with full path
  _relativePaths | This defines if the paths to the objects should be made relative
  _targetOnly | Select if we want all open objects or only the ones which are selected as target.
  _saveSystemSettings | Choose if you also want to save system settings into the ini file.
  _savePluginSettings | Choose if you want to save per Plugin global settings into the ini file.
  _saveObjectInfo | If you want to store information about all open objects this has to be true
  _fileMapping | If multiple files have the same name, all duplicates get renamed. Mapping: Id -> new file name.

Definition at line 540 of file ParseIni.cc.

## ◆ writeObjFile()

void Core::writeObjFile | ( | QString | _filename,
|  | bool | _relativePaths,
|  | bool | _targetOnly,
|  | std::map< int, QString > & | _fileMapping
| ) |  |
| private

Write current status to obj file (Application and File Options)

Writes the complete status to an obj file ( All open objects and their Information )

Todo:
  After obj writing to one file is implemented in obj plugin, remove this Function and the whole File!

Definition at line 65 of file ParseObj.cc.

The documentation for this class was generated from the following files:

- OpenFlipper/Core/Core.hh
- OpenFlipper/Core/BackupCommunication.cc
- OpenFlipper/Core/Core.cc
- OpenFlipper/Core/Logging.cc
- OpenFlipper/Core/openFunctions.cc
- OpenFlipper/Core/optionHandling.cc
- OpenFlipper/Core/ParseIni.cc
- OpenFlipper/Core/ParseObj.cc
- OpenFlipper/Core/PluginCommunication.cc
- OpenFlipper/Core/PluginLoader.cc
- OpenFlipper/Core/process.cc
- OpenFlipper/Core/RPC.cc
- OpenFlipper/Core/saveFunctions.cc
- OpenFlipper/Core/saveSettings.cc
- OpenFlipper/Core/scripting.cc
- OpenFlipper/Core/SelectionCommunication.cc
- OpenFlipper/Core/Video.cc